#include <stdio.h>
#include <time.h>
#include "qxwz_rtcm.h"
#include <unistd.h>

void qxwz_rtcm_response_callback(qxwz_rtcm data){
    printf("QXWZ_RTCM_DATA:%s\n",data.buffer);
}

void qxwz_status_response_callback(qxwz_rtcm_status code){
    printf("QXWZ_RTCM_STATUS:%d\n",code);
}


int main(int argc, const char * argv[]) {
    //设置appKey和appSecret
    //apapKey申请详细见说明文档
    qxwz_config config;
    config.appkey="";
    config.appSecret="";
    config.deviceId="";
    config.deviceType ="";
    qxwz_setting(&config);
    //启动rtcm sdk
    qxwz_rtcm_start(qxwz_rtcm_response_callback,qxwz_status_response_callback);
    sleep(3);
    int i = 0;
    //demo测试10秒发送gga
    //每秒发送gga以获取最新的rtcm数据流
    for (i = 0; i < 30; i++) {
        qxwz_rtcm_sendGGAWithGGAString("$GPGGA,000001,3112.518576,N,12127.901251,E,1,8,1,0,M,-32,M,3,0*4B\r\n");
        printf("Send GGA done\r\n");
       sleep(1);
    }
    printf("qxwz_rtcm_stop here\r\n");
    //关闭rtcm sdk
    qxwz_rtcm_stop();
    printf("qxwz_rtcm_stop done\r\n");
    return 0;
}

